package vio.tracker;

import java.util.*;

public class TrackerInfo {

	public String manufacturer = "";
	public String productType  = "";
	
	public int   serialNumber    = 0;
	public float hardwareVersion = 0.0f;
	public float firmwareVersion = 0.0f;
	
	private String code     = "";
	private String hardware = "";
	private String firmware = "";

	public TrackerInfo (String infoString) {

		try {
			manufacturer = infoString.substring(1, 16);
			code         = infoString.substring(18,33);
			productType  = infoString.substring(35,42);
			hardware     = infoString.substring(44,51);
			firmware     = infoString.substring(52,59);
		}
		catch (Exception e) { /*System.out.println(e);*/ }

		try {
			serialNumber    = (int)(Float.valueOf(code).floatValue());
			hardwareVersion = Float.valueOf(hardware).floatValue();
			firmwareVersion = Float.valueOf(firmware).floatValue();
		}
		catch (NumberFormatException e) { /*System.out.println(e);*/ }
	}

		
	public void printInfo() {

		System.out.println();
		System.out.println("Manufacturer: "+manufacturer);
		System.out.println("HardwareType: "+productType);
		System.out.println("SerialNumber: "+serialNumber);
		System.out.println("HardwareVers: "+hardwareVersion);
		System.out.println("FirmwareVers: "+firmwareVersion);
		System.out.println();
	}


}
