package vio.tracker.io;

import javax.comm.*;
import java.io.*;
import java.util.Enumeration;

public class TrackerScanner {

	public static CommPortIdentifier findTracker(boolean verbose) throws TrackerNotFoundException {
		
		Enumeration activeSerialPortIdentifiers = SerialPortScanner.findActiveSerialPorts(verbose);

		while (activeSerialPortIdentifiers.hasMoreElements()) {

			CommPortIdentifier cpi = (CommPortIdentifier)activeSerialPortIdentifiers.nextElement();

			try {
				if (verbose)
					System.out.println("testing port "+cpi.getName());

				SerialPort testPort = (SerialPort)cpi.open("vio.tracker.io.TrackerScanner",100);
				testPort.setSerialPortParams(19200,8,1,0);

				TrackerInputStream in = new TrackerInputStream ( testPort.getInputStream() );
				TrackerOutputStream out = new TrackerOutputStream (new PrintStream( testPort.getOutputStream() ));

				for (int i=0; i<100; i++) {
					out.sendCommand("R");
					if ( in.checkAnswer() ) {
						if (verbose)
							System.out.println("tracker found on port "+cpi.getName());
						testPort.close();
						return cpi;
					}
					try { Thread.sleep(10);
					} catch (InterruptedException e) {}		
				}

				testPort.close();
			}
			catch (PortInUseException e) { System.out.println(cpi.getName()+" is already in use by "+cpi.getCurrentOwner() );}
			catch (UnsupportedCommOperationException e) { System.out.println(e); }
			catch (IOException e) { System.out.println(e); }
		}

		//System.out.println("no tracker found");
		throw new TrackerNotFoundException();
	}
}

