package vio.util;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

import vio.tracker.*;
import modin.util.*;

import quicktime.*;
import quicktime.io.*;
import quicktime.std.*;
import quicktime.vr.*;
import quicktime.std.movies.*;
import quicktime.std.movies.*;
import quicktime.app.display.QTCanvas;
import quicktime.app.players.QTPlayer;

public class qtvrCanvas extends QTCanvas implements Runnable{	

	//necessary QuickTime objects
	private QTPlayer myQTPlayer;
	private QTVRInstance myQTVRInstance;
	private OpenMovieFile movieFile;
	private QTFile qtf;
	
	// the tracker driver
	private TrackerManager tracker;
	private TrackerData myTrackerData,lastTrackerData;
	private float panAngle, tiltAngle;
	private fullScreenWindow fsw;
	
	Thread myThread = null;

	public qtvrCanvas (QTFile qtf, fullScreenWindow fsw, TrackerManager tracker) {

		this.fsw = fsw;
		this.tracker = tracker;
		this.qtf = qtf;
		
		setSize(640,490);
		fsw.add(this);
			
		myTrackerData = new TrackerData();
		lastTrackerData = new TrackerData();

		addKeyListener (
			new KeyAdapter () {
				public void keyPressed (KeyEvent evt) {
		        		formKeyPressed (evt);
		        	}
		      	}
		);

		try { 	
			
			OpenMovieFile movieFile = OpenMovieFile.asRead(qtf);
			MovieController mc = new MovieController (Movie.fromFile (movieFile));
	
			myQTPlayer = new QTPlayer (mc);
			setClient(myQTPlayer, true);
			
			mc.setKeysEnabled (false);
			mc.setControllerKeysEnabled(false);
			myQTPlayer.setControllerVisible(false);
	
		} catch (Exception e) { e.printStackTrace(); QTSession.close(); }
	}

	void formKeyPressed (KeyEvent event) {
		stop();
		fsw.remove(this);
		fsw.Hide();
		fsw = null;
		tracker.close();
		tracker = null;
	}

	public void run () {
	
		try {
			QTSession.initializeVR();
			MovieController mc = myQTPlayer.getMovieController();
			myQTVRInstance= new QTVRInstance(mc.getMovie().getQTVRTrack(1),mc);
		} catch (Exception e) { e.printStackTrace(); QTSession.close();}
	
		fsw.Show(640,480);
		String trackerPortName=tracker.getTrackerPortName();
	
		while (true) {
			try {
				myTrackerData = tracker.getTrackerData();
				panAngle = myTrackerData.yawAngle;
				if (panAngle<0) panAngle = (float)360 + panAngle;
				tiltAngle = myTrackerData.pitchAngle;
				
			} catch (TrackerManagerException tme) {
				tracker.close();
				tracker=null;
				boolean trackerAvailable=false;
				while (!trackerAvailable) {
					tracker = new TrackerManager(trackerPortName,false);
					trackerAvailable=tracker.init();
					
					if (!trackerAvailable)
						System.out.println("please check the tracker ...");
				}
			}
		
			if (!myTrackerData.equals(lastTrackerData)) {
				try {
					myQTVRInstance.setPanAngle(panAngle);
					myQTVRInstance.setTiltAngle(tiltAngle);
					myQTVRInstance.update(QTVRConstants.kQTVRCurrentMode);
				} catch (QTVRException e) { /*e.printStackTrace();*/ }
			}
			
			lastTrackerData=myTrackerData;
				
			// for a framerate of about 20 fps
			try {Thread.sleep(40);}
			catch (Exception e) {}
		}
	}
	
	public void start()
	{
		if (myThread == null)
		{			
			myThread = new Thread( this );
			myThread.start();
		}

	}

	public void stop()
	{
		if (myThread != null)
		{
			myThread.stop();
			myThread = null;
			
			QTSession.close();
		}
	}

}
